/**
 * @author Administrateur
 */

var mToolTip = (function() { 
  
  var getElementsByReg = function(reg,attr){
			var tabReg=new Array();
			var tabElts=document.body.getElementsByTagName('*');
			var TEL=tabElts.length;
			if(! (reg instanceof RegExp)){return tabReg;}
			i=0;
			while(tabElts[i]){
				if(tabElts[i][attr]){
					if(reg.test(tabElts[i][attr])){tabReg.push(tabElts[i]);}
				}
				i++;         
			}
			return tabReg;
	};
  var getClass = function(ObjectDom){
  	//On récupère toute les classes de l'objet
	var listeClasse = ObjectDom.className.split(" ");
	var reg=new RegExp("mToolTip", "g");
	i=0;	
	while(listeClasse[i]){
				if(listeClasse[i]){
					if(reg.test(listeClasse[i])){break;}
				}
				i++;         
	};
	
	var finalRender = listeClasse[i].split('mToolTip')[1];
	return finalRender;
  };
  
  var getPositionFromClass = function(ObjectDom, finalRender){
  	var positionObject = getPosition(ObjectDom);
	var positionToolTip = new Array();
  	//On va récupérer la position de l'objet et renvoyer les coordonnées calculées
			switch (finalRender) {
				case "Left":
					//Récupération des propriétées de la toolTip height pour la centrer
					positionToolTip = [positionObject[0] - mToolTip.ToolTip.offsetWidth - 12, positionObject[1] + (ObjectDom.offsetHeight / 2) - (mToolTip.ToolTip.offsetHeight / 2)];
					break
				case "Right":
					positionToolTip = [positionObject[0] + ObjectDom.offsetWidth + 12, positionObject[1] + (ObjectDom.offsetHeight / 2) - (mToolTip.ToolTip.offsetHeight / 2)];
					break
				case "Top":
					positionToolTip = [positionObject[0] + (ObjectDom.offsetWidth / 2) - mToolTip.ToolTip.offsetWidth / 2, positionObject[1] - mToolTip.ToolTip.offsetHeight - 11];
					break
				case "Bottom":
					positionToolTip = [positionObject[0] + (ObjectDom.offsetWidth / 2) - mToolTip.ToolTip.offsetWidth / 2, positionObject[1] + ObjectDom.offsetHeight + 11];
					break
				case "TopLeft":
					positionToolTip = [positionObject[0] - mToolTip.ToolTip.offsetWidth - 12, positionObject[1] - mToolTip.ToolTip.offsetHeight - 11];
					break
				case "TopRight":
					positionToolTip = [positionObject[0] + ObjectDom.offsetWidth + 12, positionObject[1] - mToolTip.ToolTip.offsetHeight - 11];
					break
				case "BottomLeft":
					positionToolTip = [positionObject[0] - mToolTip.ToolTip.offsetWidth - 12, positionObject[1] + ObjectDom.offsetHeight + 11];
					break
				case "BottomRight":
					positionToolTip = [positionObject[0] + ObjectDom.offsetWidth + 12, positionObject[1] + ObjectDom.offsetHeight + 11];
					break
			}
			
			return positionToolTip;
		};
  var getPosition = function(objectDom) {
	var tmpLeft = objectDom.offsetLeft;
	var tmpTop = objectDom.offsetTop;
	var MyParent = objectDom.offsetParent;
	while(MyParent) {
		tmpLeft += MyParent.offsetLeft;
		tmpTop += MyParent.offsetTop;
		MyParent = MyParent.offsetParent;
	}
	return [tmpLeft,tmpTop]
	
  };
  
  var addEvent = function(func,onEvent,elementDom) { 
		    if (window.addEventListener) { 
				elementDom.addEventListener(onEvent, func, false); 
			} else if (document.addEventListener) { 
				elementDom.addEventListener(onEvent, func, false); 
			} else if (window.attachEvent) { 
				elementDom.attachEvent("on"+onEvent, func); 
		    } 
	  	};
  //Méthodes / variables publique 
  return {
  		"ToolTip":null,
		"inputChoice":null,
		"position" : null,
		
		"init" : function() { 
			//Récupération de tous les éléments aillant la classe spécifiée
			var hourPick = getElementsByReg(/mToolTip/,'className');
			//Affectation de l'évÃ¨nement onclick sur le champs pour afficher la tooltip
			for(var i = 0 , l = hourPick.length; i <l ; i++ ){
				addEvent(function(elemDom){return function(){
					mToolTip.buildPicker(elemDom)
				}}(hourPick[i])
				,"click",hourPick[i]);
			}
	  	},
		"addLoadListener" : function(func) { 
		    if (window.addEventListener) { 
				window.addEventListener("load", func, false); 
			} else if (document.addEventListener) { 
				document.addEventListener("load", func, false); 
			} else if (window.attachEvent) { 
				window.attachEvent("onload", func); 
		    } 
	  	},
	    "buildPicker":function(elementDom,texte,position){
				//Construction via le dom de l'objet
				var divContent = document.createElement('div');
				divContent.className = "mToolTip";
				divContent.style.visibility = "hidden";
				var divContentText = document.createElement('div');
				divContentText.className = "contentText";
				var topL = document.createElement('span');
				topL.className = "topL";
				var topR = document.createElement('span');
				topR.className = "topR";
				var bottomL = document.createElement('span');
				bottomL.className = "bottomL";
				var bottomR = document.createElement('span');
				bottomR.className = "bottomR";
				var imgAngle = document.createElement('img');
				
				//Assemblage
				divContent.appendChild(topL);
				divContent.appendChild(topR);
				divContent.appendChild(bottomL);
				divContent.appendChild(bottomR);
				divContent.appendChild(imgAngle);
				divContent.appendChild(divContentText);
				
				if(!texte){
					divContentText.innerHTML = elementDom.alt;
					mToolTip.position = getClass(elementDom);
				}
				else{
					divContentText.innerHTML = texte;
					mToolTip.position = position;
				}
				//On insère le tooltip dans la page en mode masqué
				document.body.appendChild(divContent);
				mToolTip.ToolTip = divContent;
				//Récupération de la position de l'élément
				var positionTool = getPositionFromClass(elementDom,mToolTip.position);
				
				imgAngle.src = "images/"+mToolTip.position+".png";
				imgAngle.className =  "angle"+mToolTip.position;
				mToolTip.ToolTip.style.left = positionTool[0]+ "px";
				mToolTip.ToolTip.style.top = positionTool[1]+ "px"; 
				mToolTip.ToolTip.style.visibility = "visible"
		},
		"showPicker" : function(elementDom){
			var coord = mToolTip.getPosition(elementDom);
			mToolTip.picker.style.left = coord[0] + "px";
			mToolTip.picker.style.top = coord[1] + elementDom.offsetHeight + "px";
			mToolTip.picker.style.display = "block"; 
		},
		
		"ajouterClasse" : function(element, classe) { 
	    if (element.className) { 
	      element.className += " "; 
	    } 
	 
	    element.className += classe; 
	  },
	  
	//Fonction permettant de trouver la position de l'élément ( input ) pour pouvoir positioner le calendrier
		"getPosition" : function(element) {
		var tmpLeft = element.offsetLeft;
		var tmpTop = element.offsetTop;
		var MyParent = element.offsetParent;
		while(MyParent) {
			tmpLeft += MyParent.offsetLeft;
			tmpTop += MyParent.offsetTop;
			MyParent = MyParent.offsetParent;
		}
			return [tmpLeft,tmpTop];
	}
  }; 
 
  
})();

if (document.getElementById && document.createTextNode) {
    mToolTip.addLoadListener(mToolTip.init); 
 }